# This file is part of CloudControl.
#
# CloudControl is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CloudControl is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with CloudControl.  If not, see <http://www.gnu.org/licenses/>.


""" Logging helpers.
"""

import types


# This function is taken from logging package from Python stdlib v2.7.
def getChild(self, suffix):
    """
    Get a logger which is a descendant to this one.

    This is a convenience method, such that

    logging.getLogger('abc').getChild('def.ghi')

    is the same as

    logging.getLogger('abc.def.ghi')

    It's useful, for example, when the parent logger is named using
    __name__ rather than a literal string.
    """
    if self.root is not self:
        suffix = '.'.join((self.name, suffix))
    return self.manager.getLogger(suffix)


def patch_logging():
    import logging
    logging.Logger.getChild = types.UnboundMethodType(getChild, None, logging.Logger)
